<template>
      <div class="shopping-card-item" v-bind:class="{ 'shopping-list--item-selected': hideText }">
        <div id="shopping-card-item--select-container">
          <input id="shopping-card-item--select" type="checkbox" :checked="selected" v-on:click="toggleSelect">
        </div>
        <div id="shopping-card-item--title-container">
          <h3 id="shopping-card-item--title">{{ quantity }} x {{ name }} </h3>
        </div>
        <div id="shopping-card-item--trash-container" v-on:click="deleteItem">
          <i id="shopping-card-item--trash" class="fa fa-trash w3-xlarge"></i>
        </div>
        <!-- TODO : Select/Deselect item -->
        <!-- TODO : Delete item -->
      </div>
</template>

<script>

export default {
  name: 'ShoppingItem',
  props: ['id', 'name', 'quantity', 'slug', 'selected'],
  data() {
    return {
      hideText: false 
    }
  },
  methods: {
    close () {
      // destroy the vue listeners, etc
      this.$destroy();

      // remove the element from the DOM
      this.$el.parentNode.removeChild(this.$el);
    },
    deleteItem() {

      let list = JSON.parse(localStorage.getItem( 'LIST__' + this.slug ));
      const nouveauItems = [];
      list.items.forEach(item => {
        if(item.id !== this.id) {
          nouveauItems.push(item);
        }
      });

      list.items = nouveauItems;

      localStorage.setItem('LIST__' + list.slug, JSON.stringify(list));

      this.$emit('deleted', '');
      this.close();
    },

    toggleSelect() {

      let list = JSON.parse(localStorage.getItem( 'LIST__' + this.slug ));
      list.items.forEach(item => {
        if(item.id === this.id) {
          item.selected = !item.selected;
          this.hideText = item.selected;
        }
      });

      localStorage.setItem('LIST__' + list.slug, JSON.stringify(list));
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.shopping-list--item-selected {
  text-decoration: line-through;
} 

.shopping-card-item {
    width: 100%;
    border: grey 2px solid;
    text-align: left;
    display: grid;
    grid-template-columns: 1fr 10fr 1fr;
}

#shopping-card-item--select-container {
  background-color: lightgray;
}
#shopping-card-item--select {
  text-align: center;
  width: 100%;
  height: 100%;
}


#shopping-card-item--trash-container {
  background-color: rgb(255, 62, 62);
  color: white;
}

#shopping-card-item--trash {
  cursor: pointer;
  text-align: center;
  width: 100%;
  height: 100%;
  line-height: 2em;
}

#shopping-card-item--title {
  margin: 0;
  line-height: 2em;
  padding-left: 10px;
}

</style>
